﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Controls;
using Telerik.Windows;

namespace DragDropOnGridViewHeaderRow
{
	public partial class MainPage : UserControl
	{
		private ObservableCollection<MyViewModel> gridItems = new ObservableCollection<MyViewModel>();
		private ObservableCollection<string> listBoxItems = new ObservableCollection<string>();

		public MainPage()
		{
			InitializeComponent();

			for (int i = 0; i < 30; i++)
			{
				this.gridItems.Add(new MyViewModel() { Value = i, Name = "Value" + i });
			}

			for (int i = 0; i < 10; i++)
			{
				this.listBoxItems.Add("Column" + i);
			}

			this.GridView.ItemsSource = this.gridItems;


			this.GridView.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery), true);
			this.GridView.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo), true);
			this.GridView.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery), true);
			this.GridView.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo), true);

			this.GridView1.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery), true);
			this.GridView1.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo), true);
			this.GridView1.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery), true);
			this.GridView1.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo), true);
		}

		private void OnDragQuery(object sender, DragDropQueryEventArgs e)
		{
			GridViewRow row = e.Options.Source as GridViewRow;
			RadGridView grid = row.ParentOfType<RadGridView>();
			if (e.Options.Status == DragStatus.DragQuery && grid != null)
			{
				e.Options.Payload = grid.SelectedItem;
				ContentControl cue = new ContentControl();
				cue.ContentTemplate = this.Resources["ApplicationDragTemplate"] as DataTemplate;
				cue.Content = grid.SelectedItem;
				e.Options.DragCue = cue;
				e.Options.ArrowCue = RadDragAndDropManager.GenerateArrowCue();
			}
			e.QueryResult = true;
		}

		private void OnDragInfo(object sender, DragDropEventArgs e)
		{
			GridViewRow row = e.Options.Source as GridViewRow ?? e.Options.Source.ParentOfType<GridViewRow>();
			RadGridView grid = row.ParentOfType<RadGridView>();

			if (row != null && grid != null)
			{

				IList<MyViewModel> itemsSource = grid.ItemsSource as IList<MyViewModel>;
				MyViewModel payload = e.Options.Payload as MyViewModel;

				if (e.Options.Status == DragStatus.DragComplete)
				{
					itemsSource.Remove(payload);
				}
			}
		}

		private void OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			var destination = e.Options.Destination;

			e.QueryResult = true;
		}

		private void OnDropInfo(object sender, DragDropEventArgs e)
		{
			//GridViewRow row = e.Options.Destination as GridViewRow;
			RadGridView grid = e.Options.Destination as RadGridView ?? e.Options.Destination.ParentOfType<RadGridView>();

			IList<MyViewModel> itemsSource = grid.ItemsSource as IList<MyViewModel>;

			MyViewModel payload = e.Options.Payload as MyViewModel;

			if (e.Options.Status == DragStatus.DropComplete)
			{
				if (itemsSource == null)
				{
					itemsSource = new ObservableCollection<MyViewModel>();
					grid.ItemsSource = itemsSource;
				}
				itemsSource.Add(payload);
			}
		}

		private void GridView1_RowLoaded(object sender, Telerik.Windows.Controls.GridView.RowLoadedEventArgs e)
		{
			if (e.Row is GridViewHeaderRow)
			{
				RadDragAndDropManager.SetAllowDrop(e.Row, true);
			}
		}
	}
}
